/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _271MP7JRSAVAILABILITYTYPE_AVAILABILITYPERIOD_TYPE_LOCALTYPE_H
#define _271MP7JRSAVAILABILITYTYPE_AVAILABILITYPERIOD_TYPE_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 5671<br>
 * Enumerations: <br>
 * live (mapped to XML live) <br>
 * repeat (mapped to XML repeat) <br>
 * firstShowing (mapped to XML firstShowing) <br>
 * lastShowing (mapped to XML lastShowing) <br>
 * conditionalAccess (mapped to XML conditionalAccess) <br>
 * encrypted (mapped to XML encrypted) <br>
 * payPerUse (mapped to XML payPerUse) <br>
 */
class MP7JRS_EXPORT Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType
{
public:
	/** Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		live, // Mapped to live
		repeat, // Mapped to repeat
		firstShowing, // Mapped to firstShowing
		lastShowing, // Mapped to lastShowing
		conditionalAccess, // Mapped to conditionalAccess
		encrypted, // Mapped to encrypted
		payPerUse, // Mapped to payPerUse
	};
	

// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType::Enumeration item);
	static Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsAvailabilityType_AvailabilityPeriod_type_LocalType_ExtPropDef.h



};
#endif // _271MP7JRSAVAILABILITYTYPE_AVAILABILITYPERIOD_TYPE_LOCALTYPE_H
