/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1165MP7JRSINSTRUMENTTIMBRETYPE_H
#define _1165MP7JRSINSTRUMENTTIMBRETYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsInstrumentTimbreTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsInstrumentTimbreType_ExtInclude.h


#include "Mp7JrsAudioDSType.h"
#include "Mp7JrsDSType.h"
#include "Mp7JrsMpeg7BaseType.h"
class IMp7JrsAudioDSType;
class IMp7JrsDSType_Header_CollectionType;
class IMp7JrsdurationType;
class IMp7JrsHarmonicSpectralCentroidType;
class IMp7JrsHarmonicSpectralDeviationType;
class IMp7JrsHarmonicSpectralSpreadType;
class IMp7JrsHarmonicSpectralVariationType;
class IMp7JrsInstrumentTimbreType;
class IMp7JrsintegerVector;
class IMp7JrsLogAttackTimeType;
class IMp7JrsmediaDurationType;
class IMp7JrsSpectralCentroidType;
class IMp7JrsTemporalCentroidType;
class IMp7JrsxPathRefType;
typedef Mp7JrsPtr< IMp7JrsAudioDSType > Mp7JrsAudioDSPtr;
typedef Mp7JrsPtr< IMp7JrsDSType_Header_CollectionType > Mp7JrsDSType_Header_CollectionPtr;
typedef Mp7JrsPtr< IMp7JrsdurationType > Mp7JrsdurationPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralCentroidType > Mp7JrsHarmonicSpectralCentroidPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralDeviationType > Mp7JrsHarmonicSpectralDeviationPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralSpreadType > Mp7JrsHarmonicSpectralSpreadPtr;
typedef Mp7JrsPtr< IMp7JrsHarmonicSpectralVariationType > Mp7JrsHarmonicSpectralVariationPtr;
typedef Mp7JrsPtr< IMp7JrsInstrumentTimbreType> Mp7JrsInstrumentTimbrePtr;
typedef Mp7JrsPtr< IMp7JrsintegerVector > Mp7JrsintegerVectorPtr;
typedef Mp7JrsPtr< IMp7JrsLogAttackTimeType > Mp7JrsLogAttackTimePtr;
typedef Mp7JrsPtr< IMp7JrsmediaDurationType > Mp7JrsmediaDurationPtr;
typedef Mp7JrsPtr< IMp7JrsSpectralCentroidType > Mp7JrsSpectralCentroidPtr;
typedef Mp7JrsPtr< IMp7JrsTemporalCentroidType > Mp7JrsTemporalCentroidPtr;
typedef Mp7JrsPtr< IMp7JrsxPathRefType > Mp7JrsxPathRefPtr;

/** 
 * Generated interface IMp7JrsInstrumentTimbreType for class Mp7JrsInstrumentTimbreType<br>
 * Located at: mpeg7-v2.xsd, line 1948<br>
 * Classified: Class<br>
 * Derived from: AudioDSType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsInstrumentTimbreType 
 :
		public IMp7JrsAudioDSType
{
public:
	// TODO: make these protected?
	IMp7JrsInstrumentTimbreType();
	virtual ~IMp7JrsInstrumentTimbreType();
		/** @name Sequence

		 */
		//@{
	/**
	 * Get LogAttackTime element.
	 * @return Mp7JrsLogAttackTimePtr
	 */
	virtual Mp7JrsLogAttackTimePtr GetLogAttackTime() const = 0;

	virtual bool IsValidLogAttackTime() const = 0;

	/**
	 * Set LogAttackTime element.
	 * @param item const Mp7JrsLogAttackTimePtr &
	 */
	virtual void SetLogAttackTime(const Mp7JrsLogAttackTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate LogAttackTime element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateLogAttackTime() = 0;

	/**
	 * Get HarmonicSpectralCentroid element.
	 * @return Mp7JrsHarmonicSpectralCentroidPtr
	 */
	virtual Mp7JrsHarmonicSpectralCentroidPtr GetHarmonicSpectralCentroid() const = 0;

	virtual bool IsValidHarmonicSpectralCentroid() const = 0;

	/**
	 * Set HarmonicSpectralCentroid element.
	 * @param item const Mp7JrsHarmonicSpectralCentroidPtr &
	 */
	virtual void SetHarmonicSpectralCentroid(const Mp7JrsHarmonicSpectralCentroidPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate HarmonicSpectralCentroid element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateHarmonicSpectralCentroid() = 0;

	/**
	 * Get HarmonicSpectralDeviation element.
	 * @return Mp7JrsHarmonicSpectralDeviationPtr
	 */
	virtual Mp7JrsHarmonicSpectralDeviationPtr GetHarmonicSpectralDeviation() const = 0;

	virtual bool IsValidHarmonicSpectralDeviation() const = 0;

	/**
	 * Set HarmonicSpectralDeviation element.
	 * @param item const Mp7JrsHarmonicSpectralDeviationPtr &
	 */
	virtual void SetHarmonicSpectralDeviation(const Mp7JrsHarmonicSpectralDeviationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate HarmonicSpectralDeviation element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateHarmonicSpectralDeviation() = 0;

	/**
	 * Get HarmonicSpectralSpread element.
	 * @return Mp7JrsHarmonicSpectralSpreadPtr
	 */
	virtual Mp7JrsHarmonicSpectralSpreadPtr GetHarmonicSpectralSpread() const = 0;

	virtual bool IsValidHarmonicSpectralSpread() const = 0;

	/**
	 * Set HarmonicSpectralSpread element.
	 * @param item const Mp7JrsHarmonicSpectralSpreadPtr &
	 */
	virtual void SetHarmonicSpectralSpread(const Mp7JrsHarmonicSpectralSpreadPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate HarmonicSpectralSpread element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateHarmonicSpectralSpread() = 0;

	/**
	 * Get HarmonicSpectralVariation element.
	 * @return Mp7JrsHarmonicSpectralVariationPtr
	 */
	virtual Mp7JrsHarmonicSpectralVariationPtr GetHarmonicSpectralVariation() const = 0;

	virtual bool IsValidHarmonicSpectralVariation() const = 0;

	/**
	 * Set HarmonicSpectralVariation element.
	 * @param item const Mp7JrsHarmonicSpectralVariationPtr &
	 */
	virtual void SetHarmonicSpectralVariation(const Mp7JrsHarmonicSpectralVariationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate HarmonicSpectralVariation element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateHarmonicSpectralVariation() = 0;

	/**
	 * Get SpectralCentroid element.
	 * @return Mp7JrsSpectralCentroidPtr
	 */
	virtual Mp7JrsSpectralCentroidPtr GetSpectralCentroid() const = 0;

	virtual bool IsValidSpectralCentroid() const = 0;

	/**
	 * Set SpectralCentroid element.
	 * @param item const Mp7JrsSpectralCentroidPtr &
	 */
	virtual void SetSpectralCentroid(const Mp7JrsSpectralCentroidPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate SpectralCentroid element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateSpectralCentroid() = 0;

	/**
	 * Get TemporalCentroid element.
	 * @return Mp7JrsTemporalCentroidPtr
	 */
	virtual Mp7JrsTemporalCentroidPtr GetTemporalCentroid() const = 0;

	virtual bool IsValidTemporalCentroid() const = 0;

	/**
	 * Set TemporalCentroid element.
	 * @param item const Mp7JrsTemporalCentroidPtr &
	 */
	virtual void SetTemporalCentroid(const Mp7JrsTemporalCentroidPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate TemporalCentroid element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateTemporalCentroid() = 0;

		//@}
	/**
	 * Get channels attribute.
<br>
	 * (Inherited from Mp7JrsAudioDSType)
	 * @return Mp7JrsintegerVectorPtr
	 */
	virtual Mp7JrsintegerVectorPtr Getchannels() const = 0;

	/**
	 * Get channels attribute validity information.
	 * (Inherited from Mp7JrsAudioDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existchannels() const = 0;

	/**
	 * Set channels attribute.
<br>
	 * (Inherited from Mp7JrsAudioDSType)
	 * @param item const Mp7JrsintegerVectorPtr &
	 */
	virtual void Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate channels attribute.
	 * (Inherited from Mp7JrsAudioDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatechannels() = 0;

	/**
	 * Get id attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return XMLCh *
	 */
	virtual XMLCh * Getid() const = 0;

	/**
	 * Get id attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existid() const = 0;

	/**
	 * Set id attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item XMLCh *
	 */
	virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate id attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateid() = 0;

	/**
	 * Get timeBase attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsxPathRefPtr
	 */
	virtual Mp7JrsxPathRefPtr GettimeBase() const = 0;

	/**
	 * Get timeBase attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExisttimeBase() const = 0;

	/**
	 * Set timeBase attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsxPathRefPtr &
	 */
	virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate timeBase attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidatetimeBase() = 0;

	/**
	 * Get timeUnit attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsdurationPtr
	 */
	virtual Mp7JrsdurationPtr GettimeUnit() const = 0;

	/**
	 * Get timeUnit attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExisttimeUnit() const = 0;

	/**
	 * Set timeUnit attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsdurationPtr &
	 */
	virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate timeUnit attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidatetimeUnit() = 0;

	/**
	 * Get mediaTimeBase attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsxPathRefPtr
	 */
	virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const = 0;

	/**
	 * Get mediaTimeBase attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExistmediaTimeBase() const = 0;

	/**
	 * Set mediaTimeBase attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsxPathRefPtr &
	 */
	virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate mediaTimeBase attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidatemediaTimeBase() = 0;

	/**
	 * Get mediaTimeUnit attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsmediaDurationPtr
	 */
	virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const = 0;

	/**
	 * Get mediaTimeUnit attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExistmediaTimeUnit() const = 0;

	/**
	 * Set mediaTimeUnit attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsmediaDurationPtr &
	 */
	virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate mediaTimeUnit attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidatemediaTimeUnit() = 0;

		/** @name Sequence

		 */
		//@{
	/**
	 * Get Header element.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsDSType_Header_CollectionPtr
	 */
	virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const = 0;

	/**
	 * Set Header element.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsDSType_Header_CollectionPtr &
	 */
	// Mandatory collection
	virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

		//@}
	/**
	 * Gets or creates Mp7JrsNodePtr child elements of InstrumentTimbreType.
	 * Currently this type contains 8 child elements of type "Mp7JrsNodePtr".

	 * <ul>
	 * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
	 * <li>LogAttackTime</li>
	 * <li>HarmonicSpectralCentroid</li>
	 * <li>HarmonicSpectralDeviation</li>
	 * <li>HarmonicSpectralSpread</li>
	 * <li>HarmonicSpectralVariation</li>
	 * <li>SpectralCentroid</li>
	 * <li>TemporalCentroid</li>
	 * </ul>
	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 * \par<code>A</code> 
	 * - Select all child elements named <code>A</code>.
	 * - In case of no element, create a new one.
	 * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
	 * \par<code>A[i]</code>
	 * - Select the <code>i</code>th child element of all <code>A</code>.
	 * - Please note, that XPath indexes start at 1.
	 * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
	 * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
	 * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
	 * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
	 * 
	 * \par <code>A[\@xsi:type="T"]</code>
	 *	 - Select all child elements named <code>A</code> of type <code>T</code>.
	 *	 - Currently only typenames without namespace are recognised.
	 *	 - If there is no such element, create and append a new one.
	 * \par <code>A[i][\@xsi:type="T"]</code>
	 *	 - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
	 *	 - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
	 * \par <code>A[\@xsi:type="T"][i]</code>
	 *	 - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
	 *	 - If there is no such element at index <code>i</code>, create and append one.
	 * 
	 * \par <code>A[last()]</code>
	 *	 - Select the last child element named <code>A</code>.
	 *	 - In case of no element, create a new one.
	 * \par <code>A[last()][\@xsi:type="T"]</code>
	 *	 - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
	 *	 - For collections: in case of no such type, create and append a new one.
	 *	 - For single elements: if an element with different type exists, return the empty list.
	 * 
	 * \par <code>A[\@xsi:type="T"][last()]</code>
	 *	 - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
	 *	 - For collections: in case of no such type, create and append a new one.
	 *	 - For single elements: if an element with different type exists, return the empty list.
	 * 
	 * \par <code>A[position() \> last()]</code>
	 *	 - Force creation of a child element named <code>A</code> with its default type.
	 *	 - For collections: create and append the default element.
	 *	 - For single elements: if any element exists, an exception is thrown.
	 *
	 * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
	 *	 - Force creation of a child element named <code>A</code> of type <code>T</code>.
	 *	 - For collections: create and append the element.
	 *	 - For single elements: if any element exists, an exception is thrown.
	 *
	 * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
	 *	 - Force creation of a child element named <code>A</code> of type <code>T</code>.
	 *	 - Behaves the same way as the previous expression.
	 * 
	 * 
	 * Supported XPath expressions for GetFromXPath<br>
	 * The same expressions like GetOrCreateFromXPath plus
	 * \par <code>A[position() \< i] </code>
	 *	 - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
	 *	 - <code>i</code> must be greater than -1, otherwise an exception is thrown.
	 * \par <code>A[position() \> i] </code>
	 *	 - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
	 *	 - <code>i</code> must be greater than -1, otherwise an exception is thrown.
	 * \par <code>A[position() \> i | position() \< j] </code>
	 *	 - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
	 *	 - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
	 *	 - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
	 *
	 * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

	
// no includefile for extension defined 
// file Mp7JrsInstrumentTimbreType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsInstrumentTimbreType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsInstrumentTimbreType<br>
 * Located at: mpeg7-v2.xsd, line 1948<br>
 * Classified: Class<br>
 * Derived from: AudioDSType (Class)<br>
 * Defined in mpeg7-v2.xsd, line 1948.<br>
 */
class MP7JRS_EXPORT Mp7JrsInstrumentTimbreType :
		public IMp7JrsInstrumentTimbreType
{
	friend class Mp7JrsInstrumentTimbreTypeFactory; // constructs objects

public:
	/*
	 * Retrieves the base class of Mp7JrsInstrumentTimbreType
	 
	 * @return Mp7JrsPtr< Mp7JrsAudioDSType >
	 */
	virtual Mp7JrsPtr< Mp7JrsAudioDSType > GetBase() const;
		/* @name Sequence

		 */
		//@{
	/*
	 * Get LogAttackTime element.
	 * @return Mp7JrsLogAttackTimePtr
	 */
	virtual Mp7JrsLogAttackTimePtr GetLogAttackTime() const;

	virtual bool IsValidLogAttackTime() const;

	/*
	 * Set LogAttackTime element.
	 * @param item const Mp7JrsLogAttackTimePtr &
	 */
	virtual void SetLogAttackTime(const Mp7JrsLogAttackTimePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate LogAttackTime element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateLogAttackTime();

	/*
	 * Get HarmonicSpectralCentroid element.
	 * @return Mp7JrsHarmonicSpectralCentroidPtr
	 */
	virtual Mp7JrsHarmonicSpectralCentroidPtr GetHarmonicSpectralCentroid() const;

	virtual bool IsValidHarmonicSpectralCentroid() const;

	/*
	 * Set HarmonicSpectralCentroid element.
	 * @param item const Mp7JrsHarmonicSpectralCentroidPtr &
	 */
	virtual void SetHarmonicSpectralCentroid(const Mp7JrsHarmonicSpectralCentroidPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate HarmonicSpectralCentroid element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateHarmonicSpectralCentroid();

	/*
	 * Get HarmonicSpectralDeviation element.
	 * @return Mp7JrsHarmonicSpectralDeviationPtr
	 */
	virtual Mp7JrsHarmonicSpectralDeviationPtr GetHarmonicSpectralDeviation() const;

	virtual bool IsValidHarmonicSpectralDeviation() const;

	/*
	 * Set HarmonicSpectralDeviation element.
	 * @param item const Mp7JrsHarmonicSpectralDeviationPtr &
	 */
	virtual void SetHarmonicSpectralDeviation(const Mp7JrsHarmonicSpectralDeviationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate HarmonicSpectralDeviation element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateHarmonicSpectralDeviation();

	/*
	 * Get HarmonicSpectralSpread element.
	 * @return Mp7JrsHarmonicSpectralSpreadPtr
	 */
	virtual Mp7JrsHarmonicSpectralSpreadPtr GetHarmonicSpectralSpread() const;

	virtual bool IsValidHarmonicSpectralSpread() const;

	/*
	 * Set HarmonicSpectralSpread element.
	 * @param item const Mp7JrsHarmonicSpectralSpreadPtr &
	 */
	virtual void SetHarmonicSpectralSpread(const Mp7JrsHarmonicSpectralSpreadPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate HarmonicSpectralSpread element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateHarmonicSpectralSpread();

	/*
	 * Get HarmonicSpectralVariation element.
	 * @return Mp7JrsHarmonicSpectralVariationPtr
	 */
	virtual Mp7JrsHarmonicSpectralVariationPtr GetHarmonicSpectralVariation() const;

	virtual bool IsValidHarmonicSpectralVariation() const;

	/*
	 * Set HarmonicSpectralVariation element.
	 * @param item const Mp7JrsHarmonicSpectralVariationPtr &
	 */
	virtual void SetHarmonicSpectralVariation(const Mp7JrsHarmonicSpectralVariationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate HarmonicSpectralVariation element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateHarmonicSpectralVariation();

	/*
	 * Get SpectralCentroid element.
	 * @return Mp7JrsSpectralCentroidPtr
	 */
	virtual Mp7JrsSpectralCentroidPtr GetSpectralCentroid() const;

	virtual bool IsValidSpectralCentroid() const;

	/*
	 * Set SpectralCentroid element.
	 * @param item const Mp7JrsSpectralCentroidPtr &
	 */
	virtual void SetSpectralCentroid(const Mp7JrsSpectralCentroidPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate SpectralCentroid element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateSpectralCentroid();

	/*
	 * Get TemporalCentroid element.
	 * @return Mp7JrsTemporalCentroidPtr
	 */
	virtual Mp7JrsTemporalCentroidPtr GetTemporalCentroid() const;

	virtual bool IsValidTemporalCentroid() const;

	/*
	 * Set TemporalCentroid element.
	 * @param item const Mp7JrsTemporalCentroidPtr &
	 */
	virtual void SetTemporalCentroid(const Mp7JrsTemporalCentroidPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate TemporalCentroid element.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateTemporalCentroid();

		//@}
	/*
	 * Get channels attribute.
<br>
	 * (Inherited from Mp7JrsAudioDSType)
	 * @return Mp7JrsintegerVectorPtr
	 */
	virtual Mp7JrsintegerVectorPtr Getchannels() const;

	/*
	 * Get channels attribute validity information.
	 * (Inherited from Mp7JrsAudioDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existchannels() const;

	/*
	 * Set channels attribute.
<br>
	 * (Inherited from Mp7JrsAudioDSType)
	 * @param item const Mp7JrsintegerVectorPtr &
	 */
	virtual void Setchannels(const Mp7JrsintegerVectorPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate channels attribute.
	 * (Inherited from Mp7JrsAudioDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatechannels();

	/*
	 * Get id attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return XMLCh *
	 */
	virtual XMLCh * Getid() const;

	/*
	 * Get id attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existid() const;

	/*
	 * Set id attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item XMLCh *
	 */
	virtual void Setid(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate id attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateid();

	/*
	 * Get timeBase attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsxPathRefPtr
	 */
	virtual Mp7JrsxPathRefPtr GettimeBase() const;

	/*
	 * Get timeBase attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExisttimeBase() const;

	/*
	 * Set timeBase attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsxPathRefPtr &
	 */
	virtual void SettimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate timeBase attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidatetimeBase();

	/*
	 * Get timeUnit attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsdurationPtr
	 */
	virtual Mp7JrsdurationPtr GettimeUnit() const;

	/*
	 * Get timeUnit attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExisttimeUnit() const;

	/*
	 * Set timeUnit attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsdurationPtr &
	 */
	virtual void SettimeUnit(const Mp7JrsdurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate timeUnit attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidatetimeUnit();

	/*
	 * Get mediaTimeBase attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsxPathRefPtr
	 */
	virtual Mp7JrsxPathRefPtr GetmediaTimeBase() const;

	/*
	 * Get mediaTimeBase attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExistmediaTimeBase() const;

	/*
	 * Set mediaTimeBase attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsxPathRefPtr &
	 */
	virtual void SetmediaTimeBase(const Mp7JrsxPathRefPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate mediaTimeBase attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidatemediaTimeBase();

	/*
	 * Get mediaTimeUnit attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsmediaDurationPtr
	 */
	virtual Mp7JrsmediaDurationPtr GetmediaTimeUnit() const;

	/*
	 * Get mediaTimeUnit attribute validity information.
	 * (Inherited from Mp7JrsDSType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExistmediaTimeUnit() const;

	/*
	 * Set mediaTimeUnit attribute.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsmediaDurationPtr &
	 */
	virtual void SetmediaTimeUnit(const Mp7JrsmediaDurationPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate mediaTimeUnit attribute.
	 * (Inherited from Mp7JrsDSType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidatemediaTimeUnit();

		/* @name Sequence

		 */
		//@{
	/*
	 * Get Header element.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @return Mp7JrsDSType_Header_CollectionPtr
	 */
	virtual Mp7JrsDSType_Header_CollectionPtr GetHeader() const;

	/*
	 * Set Header element.
<br>
	 * (Inherited from Mp7JrsDSType)
	 * @param item const Mp7JrsDSType_Header_CollectionPtr &
	 */
	// Mandatory collection
	virtual void SetHeader(const Mp7JrsDSType_Header_CollectionPtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

		//@}
	/*
	 * Gets or creates Mp7JrsNodePtr child elements of InstrumentTimbreType.
	 * Currently this type contains 8 child elements of type "Mp7JrsNodePtr".

	 * <ul>
	 * <li>urn:mpeg:mpeg7:schema:2004:Header</li>
	 * <li>LogAttackTime</li>
	 * <li>HarmonicSpectralCentroid</li>
	 * <li>HarmonicSpectralDeviation</li>
	 * <li>HarmonicSpectralSpread</li>
	 * <li>HarmonicSpectralVariation</li>
	 * <li>SpectralCentroid</li>
	 * <li>TemporalCentroid</li>
	 * </ul>
	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 * \par<code>A</code> 
	 * - Select all child elements named <code>A</code>.
	 * - In case of no element, create a new one.
	 * - For collections: all subsequent XPath expressions are applied on all collection items (e.g. <code>A/B</code> query or create, childnodes <code>B</code> of all <code>A</code>s). 
	 * \par<code>A[i]</code>
	 * - Select the <code>i</code>th child element of all <code>A</code>.
	 * - Please note, that XPath indexes start at 1.
	 * - If there is no such <code>i</code>th element, try to create a new one at index <code>i</code>.
	 * - Single elements require <code>i</code> to be 1 otherwise an exception is thrown.
	 * - For collections, <code>i</code> must not exceed the number of existing items +1 (appending is allowed, filling gaps not).
	 * - If the index is too high, a <code>MissingElementException</code> is thrown, and you can extract the last valid index. (Example: If a collection contains 2 elements and you are requesting the 4th element).
	 * 
	 * \par <code>A[\@xsi:type="T"]</code>
	 *	 - Select all child elements named <code>A</code> of type <code>T</code>.
	 *	 - Currently only typenames without namespace are recognised.
	 *	 - If there is no such element, create and append a new one.
	 * \par <code>A[i][\@xsi:type="T"]</code>
	 *	 - Select the <code>i</code>th child element named <code>A</code>, which must be of type <code>T</code>.
	 *	 - If there is no such element at index <code>i</code>, a new one is created and inserted (appended).
	 * \par <code>A[\@xsi:type="T"][i]</code>
	 *	 - Out of all child elements named <code>A</code> of type <code>T</code>, take the <code>i</code>th one.
	 *	 - If there is no such element at index <code>i</code>, create and append one.
	 * 
	 * \par <code>A[last()]</code>
	 *	 - Select the last child element named <code>A</code>.
	 *	 - In case of no element, create a new one.
	 * \par <code>A[last()][\@xsi:type="T"]</code>
	 *	 - Select the last child element named <code>A</code>, which must be of type <code>T</code>.
	 *	 - For collections: in case of no such type, create and append a new one.
	 *	 - For single elements: if an element with different type exists, return the empty list.
	 * 
	 * \par <code>A[\@xsi:type="T"][last()]</code>
	 *	 - Out of all child elements named <code>A</code> of type <code>T</code>, take the last one.
	 *	 - For collections: in case of no such type, create and append a new one.
	 *	 - For single elements: if an element with different type exists, return the empty list.
	 * 
	 * \par <code>A[position() \> last()]</code>
	 *	 - Force creation of a child element named <code>A</code> with its default type.
	 *	 - For collections: create and append the default element.
	 *	 - For single elements: if any element exists, an exception is thrown.
	 *
	 * \par <code>A[position() \> last()][\@xsi:type="T"]</code>
	 *	 - Force creation of a child element named <code>A</code> of type <code>T</code>.
	 *	 - For collections: create and append the element.
	 *	 - For single elements: if any element exists, an exception is thrown.
	 *
	 * \par <code>A[\@xsi:type="T"][position() \> last()]</code>
	 *	 - Force creation of a child element named <code>A</code> of type <code>T</code>.
	 *	 - Behaves the same way as the previous expression.
	 * 
	 * 
	 * Supported XPath expressions for GetFromXPath<br>
	 * The same expressions like GetOrCreateFromXPath plus
	 * \par <code>A[position() \< i] </code>
	 *	 - Select all child elements named <code>A</code> at indexes lower than <code>i</code>.
	 *	 - <code>i</code> must be greater than -1, otherwise an exception is thrown.
	 * \par <code>A[position() \> i] </code>
	 *	 - Select all child elements named <code>A</code> at indexes greater than <code>i</code>.
	 *	 - <code>i</code> must be greater than -1, otherwise an exception is thrown.
	 * \par <code>A[position() \> i | position() \< j] </code>
	 *	 - Select all child elements named <code>A</code> at indexes greater than <code>i</code> and lower than <code>j</code>.
	 *	 - <code>i</code> and <code>j</code> must be greater than -1, otherwise an exception is thrown.
	 *	 - If <code>i</code> is greater than <code>j</code> then an empty list is returned.
	 *
	 * These three expressions can be combined with the <code>\@xsi:type</code> attribute to get a more restricted query.
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

	

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsInstrumentTimbreType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsInstrumentTimbreType();

protected:
	Mp7JrsInstrumentTimbreType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:

	// Base Class
	Mp7JrsPtr< Mp7JrsAudioDSType > m_Base;

	Mp7JrsLogAttackTimePtr m_LogAttackTime;
	bool m_LogAttackTime_Exist; // For optional elements 
	Mp7JrsHarmonicSpectralCentroidPtr m_HarmonicSpectralCentroid;
	bool m_HarmonicSpectralCentroid_Exist; // For optional elements 
	Mp7JrsHarmonicSpectralDeviationPtr m_HarmonicSpectralDeviation;
	bool m_HarmonicSpectralDeviation_Exist; // For optional elements 
	Mp7JrsHarmonicSpectralSpreadPtr m_HarmonicSpectralSpread;
	bool m_HarmonicSpectralSpread_Exist; // For optional elements 
	Mp7JrsHarmonicSpectralVariationPtr m_HarmonicSpectralVariation;
	bool m_HarmonicSpectralVariation_Exist; // For optional elements 
	Mp7JrsSpectralCentroidPtr m_SpectralCentroid;
	bool m_SpectralCentroid_Exist; // For optional elements 
	Mp7JrsTemporalCentroidPtr m_TemporalCentroid;
	bool m_TemporalCentroid_Exist; // For optional elements 

// no includefile for extension defined 
// file Mp7JrsInstrumentTimbreType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1165MP7JRSINSTRUMENTTIMBRETYPE_H

