/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


#ifndef _1170MP7JRSINTEGERMATRIXTYPEFACTORY_H
#define _1170MP7JRSINTEGERMATRIXTYPEFACTORY_H

#include "Mp7JrsDefines.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsFactory.h"
#include "Mp7JrsPtr.h"
#include "Mp7JrsPtrTypes.h"

/*
 * Generated factory Mp7JrsIntegerMatrixTypeFactory<br>
 * for class Mp7JrsIntegerMatrixType:<br>
 * Located at: mpeg7-v2.xsd, line 3396<br>
 * Classified: Class<br>
 * Derived from: integerVector (Collection)<br>
 */

class MP7JRS_EXPORT Mp7JrsIntegerMatrixTypeFactory :
	public Mp7JrsFactory
{
public:
	Mp7JrsIntegerMatrixTypeFactory();
	virtual ~Mp7JrsIntegerMatrixTypeFactory();

	virtual const char * GetTypeName() const;
	virtual Mp7JrsNodePtr CreateObject();
};

#endif // _1170MP7JRSINTEGERMATRIXTYPEFACTORY_H
