/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1233MP7JRSLOGICALUNITLOCATORTYPE_LOCALTYPE_H
#define _1233MP7JRSLOGICALUNITLOCATORTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsLogicalUnitLocatorType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtInclude.h


class IMp7JrsLogicalUnitLocatorType_LocalType;
class IMp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0;
class IMp7JrsLogicalUnitLocatorType_ReferenceUnit_LocalType0;
typedef Mp7JrsPtr< IMp7JrsLogicalUnitLocatorType_LocalType> Mp7JrsLogicalUnitLocatorType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsLogicalUnitLocatorType_LogicalUnit_LocalType0 > Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr;
typedef Mp7JrsPtr< IMp7JrsLogicalUnitLocatorType_ReferenceUnit_LocalType0 > Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr;

/** 
 * Generated interface IMp7JrsLogicalUnitLocatorType_LocalType for class Mp7JrsLogicalUnitLocatorType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsLogicalUnitLocatorType_LocalType 
 :
		public Mp7JrsNode
{
public:
	// TODO: make these protected?
	IMp7JrsLogicalUnitLocatorType_LocalType();
	virtual ~IMp7JrsLogicalUnitLocatorType_LocalType();
		/** @name Choice

		 */
		//@{
	/**
	 * Get LogicalUnit element.
	 * @return Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr
	 */
	virtual Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr GetLogicalUnit() const = 0;

	/**
	 * Set LogicalUnit element.
	 * @param item const Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr &
	 */
	// Mandatory			
	virtual void SetLogicalUnit(const Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Get ReferenceUnit element.
	 * @return Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr
	 */
	virtual Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr GetReferenceUnit() const = 0;

	/**
	 * Set ReferenceUnit element.
	 * @param item const Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr &
	 */
	// Mandatory			
	virtual void SetReferenceUnit(const Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

		//@}
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsLogicalUnitLocatorType_LocalType<br>
 * Defined in mpeg7-v2.xsd, line 3844.<br>
 */
class MP7JRS_EXPORT Mp7JrsLogicalUnitLocatorType_LocalType :
		public IMp7JrsLogicalUnitLocatorType_LocalType
{
	friend class Mp7JrsLogicalUnitLocatorType_LocalTypeFactory; // constructs objects

public:
		/* @name Choice

		 */
		//@{
	/*
	 * Get LogicalUnit element.
	 * @return Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr
	 */
	virtual Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr GetLogicalUnit() const;

	/*
	 * Set LogicalUnit element.
	 * @param item const Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr &
	 */
	// Mandatory			
	virtual void SetLogicalUnit(const Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Get ReferenceUnit element.
	 * @return Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr
	 */
	virtual Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr GetReferenceUnit() const;

	/*
	 * Set ReferenceUnit element.
	 * @param item const Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr &
	 */
	// Mandatory			
	virtual void SetReferenceUnit(const Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

		//@}

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsLogicalUnitLocatorType_LocalType();

protected:
	Mp7JrsLogicalUnitLocatorType_LocalType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
	Mp7JrsLogicalUnitLocatorType_LogicalUnit_Local0Ptr m_LogicalUnit;
	Mp7JrsLogicalUnitLocatorType_ReferenceUnit_Local0Ptr m_ReferenceUnit;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsLogicalUnitLocatorType_LocalType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1233MP7JRSLOGICALUNITLOCATORTYPE_LOCALTYPE_H

