/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1281MP7JRSMEDIAFORMATTYPE_BITRATE_LOCALTYPE_H
#define _1281MP7JRSMEDIAFORMATTYPE_BITRATE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMediaFormatType_BitRate_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtInclude.h


class IMp7JrsMediaFormatType_BitRate_LocalType;
typedef Mp7JrsPtr< IMp7JrsMediaFormatType_BitRate_LocalType> Mp7JrsMediaFormatType_BitRate_LocalPtr;

/** 
 * Generated interface IMp7JrsMediaFormatType_BitRate_LocalType for class Mp7JrsMediaFormatType_BitRate_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 5039<br>
 * Classified: Class<br>
 * Derived from: nonNegativeInteger (Value)<br>
 */
class MP7JRS_EXPORT IMp7JrsMediaFormatType_BitRate_LocalType 
 :
		public Mp7JrsNode
{
public:
	// TODO: make these protected?
	IMp7JrsMediaFormatType_BitRate_LocalType();
	virtual ~IMp7JrsMediaFormatType_BitRate_LocalType();
	/**
	 * Sets the content of Mp7JrsMediaFormatType_BitRate_LocalType	 * @param item unsigned
	 */
	virtual void SetContent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Retrieves the content of Mp7JrsMediaFormatType_BitRate_LocalType 
	 * @return unsigned
	 */
	virtual unsigned GetContent() const = 0;

	/**
	 * Get variable attribute.
	 * @return bool
	 */
	virtual bool Getvariable() const = 0;

	/**
	 * Get variable attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existvariable() const = 0;

	/**
	 * Set variable attribute.
	 * @param item bool
	 */
	virtual void Setvariable(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate variable attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatevariable() = 0;

	/**
	 * Get minimum attribute.
	 * @return unsigned
	 */
	virtual unsigned Getminimum() const = 0;

	/**
	 * Get minimum attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existminimum() const = 0;

	/**
	 * Set minimum attribute.
	 * @param item unsigned
	 */
	virtual void Setminimum(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate minimum attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateminimum() = 0;

	/**
	 * Get average attribute.
	 * @return unsigned
	 */
	virtual unsigned Getaverage() const = 0;

	/**
	 * Get average attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existaverage() const = 0;

	/**
	 * Set average attribute.
	 * @param item unsigned
	 */
	virtual void Setaverage(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate average attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateaverage() = 0;

	/**
	 * Get maximum attribute.
	 * @return unsigned
	 */
	virtual unsigned Getmaximum() const = 0;

	/**
	 * Get maximum attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existmaximum() const = 0;

	/**
	 * Set maximum attribute.
	 * @param item unsigned
	 */
	virtual void Setmaximum(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate maximum attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatemaximum() = 0;

	/**
	 * Gets or creates Mp7JrsNodePtr child elements of MediaFormatType_BitRate_LocalType.
	 * Currently just supports rudimentary XPath expressions as MediaFormatType_BitRate_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

	
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMediaFormatType_BitRate_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 5039<br>
 * Classified: Class<br>
 * Derived from: nonNegativeInteger (Value)<br>
 * Defined in mpeg7-v2.xsd, line 5039.<br>
 */
class MP7JRS_EXPORT Mp7JrsMediaFormatType_BitRate_LocalType :
		public IMp7JrsMediaFormatType_BitRate_LocalType
{
	friend class Mp7JrsMediaFormatType_BitRate_LocalTypeFactory; // constructs objects

public:
	/*
	 * Sets the content of Mp7JrsMediaFormatType_BitRate_LocalType	 * @param item unsigned
	 */
	virtual void SetContent(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Retrieves the content of Mp7JrsMediaFormatType_BitRate_LocalType 
	 * @return unsigned
	 */
	virtual unsigned GetContent() const;

	/*
	 * Get variable attribute.
	 * @return bool
	 */
	virtual bool Getvariable() const;

	/*
	 * Get variable attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existvariable() const;

	/*
	 * Set variable attribute.
	 * @param item bool
	 */
	virtual void Setvariable(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate variable attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatevariable();

	/*
	 * Get minimum attribute.
	 * @return unsigned
	 */
	virtual unsigned Getminimum() const;

	/*
	 * Get minimum attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existminimum() const;

	/*
	 * Set minimum attribute.
	 * @param item unsigned
	 */
	virtual void Setminimum(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate minimum attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateminimum();

	/*
	 * Get average attribute.
	 * @return unsigned
	 */
	virtual unsigned Getaverage() const;

	/*
	 * Get average attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existaverage() const;

	/*
	 * Set average attribute.
	 * @param item unsigned
	 */
	virtual void Setaverage(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate average attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidateaverage();

	/*
	 * Get maximum attribute.
	 * @return unsigned
	 */
	virtual unsigned Getmaximum() const;

	/*
	 * Get maximum attribute validity information.
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool Existmaximum() const;

	/*
	 * Set maximum attribute.
	 * @param item unsigned
	 */
	virtual void Setmaximum(unsigned item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate maximum attribute.
	 
	 * (Validate it again by setting a value)
	 */
	virtual void Invalidatemaximum();

	/*
	 * Gets or creates Mp7JrsNodePtr child elements of MediaFormatType_BitRate_LocalType.
	 * Currently just supports rudimentary XPath expressions as MediaFormatType_BitRate_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

	

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Parse the content from a string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool ContentFromString(const XMLCh * const txt);

	/* Convert the content to string.  Note, this is purely for ComplexTypes with SimpleContent and SimpleTypes. All other types may return NULL or the class name.
	 * @return the allocated XMLCh * if conversion was successful. The caller must free memory using Mp7JrsUtil.deallocate().
	 */
	virtual XMLCh * ContentToString() const;


	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsMediaFormatType_BitRate_LocalType();

protected:
	Mp7JrsMediaFormatType_BitRate_LocalType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	bool m_variable;
	bool m_variable_Exist;
	bool m_variable_Default;
	unsigned m_minimum;
	bool m_minimum_Exist;
	unsigned m_average;
	bool m_average_Exist;
	unsigned m_maximum;
	bool m_maximum_Exist;

	// Base Value
	unsigned m_Base;


// no includefile for extension defined 
// file Mp7JrsMediaFormatType_BitRate_LocalType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1281MP7JRSMEDIAFORMATTYPE_BITRATE_LOCALTYPE_H

