/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _1303MP7JRSMEDIAFORMATTYPE_VISUALCODING_FRAME_STRUCTURE_LOCALTYPE_H
#define _1303MP7JRSMEDIAFORMATTYPE_VISUALCODING_FRAME_STRUCTURE_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 5116<br>
 * Enumerations: <br>
 * progressive (mapped to XML progressive) <br>
 * interlaced (mapped to XML interlaced) <br>
 */
class MP7JRS_EXPORT Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType
{
public:
	/** Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		progressive, // Mapped to progressive
		interlaced, // Mapped to interlaced
	};
	

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration item);
	static Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsMediaFormatType_VisualCoding_Frame_structure_LocalType_ExtPropDef.h



};
#endif // _1303MP7JRSMEDIAFORMATTYPE_VISUALCODING_FRAME_STRUCTURE_LOCALTYPE_H
