/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1473MP7JRSMOTIONACTIVITYTYPE_SPATIALDISTRIBUTIONPARAMS_LOCALTYPE_H
#define _1473MP7JRSMOTIONACTIVITYTYPE_SPATIALDISTRIBUTIONPARAMS_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsMotionActivityType_SpatialDistributionParams_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtInclude.h


class IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType;
class IMp7Jrsunsigned5;
class IMp7Jrsunsigned6;
typedef Mp7JrsPtr< IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType> Mp7JrsMotionActivityType_SpatialDistributionParams_LocalPtr;
typedef Mp7JrsPtr< IMp7Jrsunsigned5 > Mp7Jrsunsigned5Ptr;
typedef Mp7JrsPtr< IMp7Jrsunsigned6 > Mp7Jrsunsigned6Ptr;

/** 
 * Generated interface IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType for class Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 1193<br>
 * Classified: Class<br>
 */
class MP7JRS_EXPORT IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType 
 :
		public Mp7JrsNode
{
public:
	// TODO: make these protected?
	IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType();
	virtual ~IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType();
	/**
	 * Get numOfShortRuns attribute.
	 * @return Mp7Jrsunsigned6Ptr
	 */
	virtual Mp7Jrsunsigned6Ptr GetnumOfShortRuns() const = 0;

	/**
	 * Set numOfShortRuns attribute.
	 * @param item const Mp7Jrsunsigned6Ptr &
	 */
	// Mandatory
	virtual void SetnumOfShortRuns(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Get numOfMediumRuns attribute.
	 * @return Mp7Jrsunsigned5Ptr
	 */
	virtual Mp7Jrsunsigned5Ptr GetnumOfMediumRuns() const = 0;

	/**
	 * Set numOfMediumRuns attribute.
	 * @param item const Mp7Jrsunsigned5Ptr &
	 */
	// Mandatory
	virtual void SetnumOfMediumRuns(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Get numOfLongRuns attribute.
	 * @return Mp7Jrsunsigned5Ptr
	 */
	virtual Mp7Jrsunsigned5Ptr GetnumOfLongRuns() const = 0;

	/**
	 * Set numOfLongRuns attribute.
	 * @param item const Mp7Jrsunsigned5Ptr &
	 */
	// Mandatory
	virtual void SetnumOfLongRuns(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Gets or creates Mp7JrsNodePtr child elements of MotionActivityType_SpatialDistributionParams_LocalType.
	 * Currently just supports rudimentary XPath expressions as MotionActivityType_SpatialDistributionParams_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

	
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 1193<br>
 * Classified: Class<br>
 * Defined in mpeg7-v2.xsd, line 1193.<br>
 */
class MP7JRS_EXPORT Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType :
		public IMp7JrsMotionActivityType_SpatialDistributionParams_LocalType
{
	friend class Mp7JrsMotionActivityType_SpatialDistributionParams_LocalTypeFactory; // constructs objects

public:
	/*
	 * Get numOfShortRuns attribute.
	 * @return Mp7Jrsunsigned6Ptr
	 */
	virtual Mp7Jrsunsigned6Ptr GetnumOfShortRuns() const;

	/*
	 * Set numOfShortRuns attribute.
	 * @param item const Mp7Jrsunsigned6Ptr &
	 */
	// Mandatory
	virtual void SetnumOfShortRuns(const Mp7Jrsunsigned6Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Get numOfMediumRuns attribute.
	 * @return Mp7Jrsunsigned5Ptr
	 */
	virtual Mp7Jrsunsigned5Ptr GetnumOfMediumRuns() const;

	/*
	 * Set numOfMediumRuns attribute.
	 * @param item const Mp7Jrsunsigned5Ptr &
	 */
	// Mandatory
	virtual void SetnumOfMediumRuns(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Get numOfLongRuns attribute.
	 * @return Mp7Jrsunsigned5Ptr
	 */
	virtual Mp7Jrsunsigned5Ptr GetnumOfLongRuns() const;

	/*
	 * Set numOfLongRuns attribute.
	 * @param item const Mp7Jrsunsigned5Ptr &
	 */
	// Mandatory
	virtual void SetnumOfLongRuns(const Mp7Jrsunsigned5Ptr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Gets or creates Mp7JrsNodePtr child elements of MotionActivityType_SpatialDistributionParams_LocalType.
	 * Currently just supports rudimentary XPath expressions as MotionActivityType_SpatialDistributionParams_LocalType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

	

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType();

protected:
	Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	Mp7Jrsunsigned6Ptr m_numOfShortRuns;
	Mp7Jrsunsigned5Ptr m_numOfMediumRuns;
	Mp7Jrsunsigned5Ptr m_numOfLongRuns;



// no includefile for extension defined 
// file Mp7JrsMotionActivityType_SpatialDistributionParams_LocalType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1473MP7JRSMOTIONACTIVITYTYPE_SPATIALDISTRIBUTIONPARAMS_LOCALTYPE_H

