/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _1957MP7JRSSEMANTICBAGTYPE_LOCALTYPE_H
#define _1957MP7JRSSEMANTICBAGTYPE_LOCALTYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsSemanticBagType_LocalTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsSemanticBagType_LocalType_ExtInclude.h


class IMp7JrsReferenceType;
class IMp7JrsSemanticBagType_LocalType;
class IMp7JrsSemanticBaseType;
typedef Mp7JrsPtr< IMp7JrsReferenceType > Mp7JrsReferencePtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBagType_LocalType> Mp7JrsSemanticBagType_LocalPtr;
typedef Mp7JrsPtr< IMp7JrsSemanticBaseType > Mp7JrsSemanticBasePtr;

/** 
 * Generated interface IMp7JrsSemanticBagType_LocalType for class Mp7JrsSemanticBagType_LocalType<br>
 */
class MP7JRS_EXPORT IMp7JrsSemanticBagType_LocalType 
 :
		public Mp7JrsNode
{
public:
	// TODO: make these protected?
	IMp7JrsSemanticBagType_LocalType();
	virtual ~IMp7JrsSemanticBagType_LocalType();
		/** @name Choice

		 */
		//@{
	/**
	 * Get SemanticBase element.
	 * @return Mp7JrsPtr< Mp7JrsNode >
	 * Possible types (within this library):
	 * <ul>
	 * <li>IMp7JrsAgentObjectPtr</li>
	 * <li>IMp7JrsAnalyticModelType_Semantics_LocalPtr</li>
	 * <li>IMp7JrsConceptPtr</li>
	 * <li>IMp7JrsEventPtr</li>
	 * <li>IMp7JrsObjectPtr</li>
	 * <li>IMp7JrsSemanticPlacePtr</li>
	 * <li>IMp7JrsSemanticStatePtr</li>
	 * <li>IMp7JrsSemanticTimePtr</li>
	 * <li>IMp7JrsSemanticPtr</li>
	 * </ul>
	 */
	virtual Mp7JrsPtr< Mp7JrsNode > GetSemanticBase() const = 0;

	/**
	 * Set SemanticBase element.
	 * @param item const Mp7JrsPtr< Mp7JrsNode > &
	 * Valid types for item:
	 * <ul>
	 * <li>IMp7JrsAgentObjectPtr</li>
	 * <li>IMp7JrsAnalyticModelType_Semantics_LocalPtr</li>
	 * <li>IMp7JrsConceptPtr</li>
	 * <li>IMp7JrsEventPtr</li>
	 * <li>IMp7JrsObjectPtr</li>
	 * <li>IMp7JrsSemanticPlacePtr</li>
	 * <li>IMp7JrsSemanticStatePtr</li>
	 * <li>IMp7JrsSemanticTimePtr</li>
	 * <li>IMp7JrsSemanticPtr</li>
	 * </ul>
	 */
	virtual void SetSemanticBase(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Get SemanticBaseRef element.
	 * @return Mp7JrsReferencePtr
	 */
	virtual Mp7JrsReferencePtr GetSemanticBaseRef() const = 0;

	/**
	 * Set SemanticBaseRef element.
	 * @param item const Mp7JrsReferencePtr &
	 */
	virtual void SetSemanticBaseRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

		//@}
// no includefile for extension defined 
// file Mp7JrsSemanticBagType_LocalType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsSemanticBagType_LocalType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsSemanticBagType_LocalType<br>
 * Defined in mpeg7-v2.xsd, line 7155.<br>
 */
class MP7JRS_EXPORT Mp7JrsSemanticBagType_LocalType :
		public IMp7JrsSemanticBagType_LocalType
{
	friend class Mp7JrsSemanticBagType_LocalTypeFactory; // constructs objects

public:
		/* @name Choice

		 */
		//@{
	/*
	 * Get SemanticBase element.
	 * @return Mp7JrsPtr< Mp7JrsNode >
	 * Possible types (within this library):
	 * <ul>
	 * <li>IMp7JrsAgentObjectPtr</li>
	 * <li>IMp7JrsAnalyticModelType_Semantics_LocalPtr</li>
	 * <li>IMp7JrsConceptPtr</li>
	 * <li>IMp7JrsEventPtr</li>
	 * <li>IMp7JrsObjectPtr</li>
	 * <li>IMp7JrsSemanticPlacePtr</li>
	 * <li>IMp7JrsSemanticStatePtr</li>
	 * <li>IMp7JrsSemanticTimePtr</li>
	 * <li>IMp7JrsSemanticPtr</li>
	 * </ul>
	 */
	virtual Mp7JrsPtr< Mp7JrsNode > GetSemanticBase() const;

	/*
	 * Set SemanticBase element.
	 * @param item const Mp7JrsPtr< Mp7JrsNode > &
	 * Valid types for item:
	 * <ul>
	 * <li>IMp7JrsAgentObjectPtr</li>
	 * <li>IMp7JrsAnalyticModelType_Semantics_LocalPtr</li>
	 * <li>IMp7JrsConceptPtr</li>
	 * <li>IMp7JrsEventPtr</li>
	 * <li>IMp7JrsObjectPtr</li>
	 * <li>IMp7JrsSemanticPlacePtr</li>
	 * <li>IMp7JrsSemanticStatePtr</li>
	 * <li>IMp7JrsSemanticTimePtr</li>
	 * <li>IMp7JrsSemanticPtr</li>
	 * </ul>
	 */
	virtual void SetSemanticBase(const Mp7JrsPtr< Mp7JrsNode > & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Get SemanticBaseRef element.
	 * @return Mp7JrsReferencePtr
	 */
	virtual Mp7JrsReferencePtr GetSemanticBaseRef() const;

	/*
	 * Set SemanticBaseRef element.
	 * @param item const Mp7JrsReferencePtr &
	 */
	virtual void SetSemanticBaseRef(const Mp7JrsReferencePtr & item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

		//@}

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsSemanticBagType_LocalType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsSemanticBagType_LocalType();

protected:
	Mp7JrsSemanticBagType_LocalType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:


// DefinionChoice
	Mp7JrsPtr< Mp7JrsNode > m_SemanticBase;
	Mp7JrsReferencePtr m_SemanticBaseRef;
// End DefinionChoice

// no includefile for extension defined 
// file Mp7JrsSemanticBagType_LocalType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _1957MP7JRSSEMANTICBAGTYPE_LOCALTYPE_H

