/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _2149MP7JRSSPACEFREQUENCYVIEWTYPE_ORDER_LOCALTYPE_H
#define _2149MP7JRSSPACEFREQUENCYVIEWTYPE_ORDER_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyViewType_order_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrsSpaceFrequencyViewType_order_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 7792<br>
 * Enumerations: <br>
 * spaceFrequency (mapped to XML spaceFrequency) <br>
 * frequencySpace (mapped to XML frequencySpace) <br>
 * commutative (mapped to XML commutative) <br>
 * partitionable (mapped to XML partitionable) <br>
 * mixed (mapped to XML mixed) <br>
 */
class MP7JRS_EXPORT Mp7JrsSpaceFrequencyViewType_order_LocalType
{
public:
	/** Mp7JrsSpaceFrequencyViewType_order_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		spaceFrequency, // Mapped to spaceFrequency
		frequencySpace, // Mapped to frequencySpace
		commutative, // Mapped to commutative
		partitionable, // Mapped to partitionable
		mixed, // Mapped to mixed
	};
	

// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyViewType_order_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrsSpaceFrequencyViewType_order_LocalType::Enumeration item);
	static Mp7JrsSpaceFrequencyViewType_order_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrsSpaceFrequencyViewType_order_LocalType_ExtPropDef.h



};
#endif // _2149MP7JRSSPACEFREQUENCYVIEWTYPE_ORDER_LOCALTYPE_H
