/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/


// ClassType_H.template
#ifndef _2651MP7JRSURIFRAGMENTREFERENCETYPE_H
#define _2651MP7JRSURIFRAGMENTREFERENCETYPE_H

#include <xercesc/util/PlatformUtils.hpp>
#include <xercesc/util/XMLString.hpp>
#include <xercesc/dom/DOM.hpp>

#include "Mp7JrsDefines.h"
#include "Mp7JrsFactoryDefines.h"
#include "Mp7JrsURIFragmentReferenceTypeFactory.h"
#include "Mp7JrsNode.h"
#include "Mp7JrsConvert.h"


// no includefile for extension defined 
// file Mp7JrsURIFragmentReferenceType_ExtInclude.h


#include "Mp7JrsFragmentReferenceType.h"
class IMp7JrsFragmentReferenceType;
class IMp7JrsURIFragmentReferenceType;
typedef Mp7JrsPtr< IMp7JrsFragmentReferenceType > Mp7JrsFragmentReferencePtr;
typedef Mp7JrsPtr< IMp7JrsURIFragmentReferenceType> Mp7JrsURIFragmentReferencePtr;

/** 
 * Generated interface IMp7JrsURIFragmentReferenceType for class Mp7JrsURIFragmentReferenceType<br>
 * Located at: mpeg7-v2.xsd, line 139<br>
 * Classified: Class<br>
 * Derived from: FragmentReferenceType (Class)<br>
 */
class MP7JRS_EXPORT IMp7JrsURIFragmentReferenceType 
 :
		public IMp7JrsFragmentReferenceType
{
public:
	// TODO: make these protected?
	IMp7JrsURIFragmentReferenceType();
	virtual ~IMp7JrsURIFragmentReferenceType();
	/**
	 * Get href attribute.
	 * @return XMLCh *
	 */
	virtual XMLCh * Gethref() const = 0;

	/**
	 * Set href attribute.
	 * @param item XMLCh *
	 */
	// Mandatory
	virtual void Sethref(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;

	/**
	 * Get isDeferred attribute.
<br>
	 * (Inherited from Mp7JrsFragmentReferenceType)
	 * @return bool
	 */
	virtual bool GetisDeferred() const = 0;

	/**
	 * Get isDeferred attribute validity information.
	 * (Inherited from Mp7JrsFragmentReferenceType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExistisDeferred() const = 0;

	/**
	 * Set isDeferred attribute.
<br>
	 * (Inherited from Mp7JrsFragmentReferenceType)
	 * @param item bool
	 */
	virtual void SetisDeferred(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT) = 0;


	/**
	 * Invalidate isDeferred attribute.
	 * (Inherited from Mp7JrsFragmentReferenceType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateisDeferred() = 0;

	/**
	 * Gets or creates Mp7JrsNodePtr child elements of URIFragmentReferenceType.
	 * Currently just supports rudimentary XPath expressions as URIFragmentReferenceType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL) = 0;

	
// no includefile for extension defined 
// file Mp7JrsURIFragmentReferenceType_ExtMethodDef.h


// no includefile for extension defined 
// file Mp7JrsURIFragmentReferenceType_ExtPropDef.h

};




/*
 * Generated class Mp7JrsURIFragmentReferenceType<br>
 * Located at: mpeg7-v2.xsd, line 139<br>
 * Classified: Class<br>
 * Derived from: FragmentReferenceType (Class)<br>
 * Defined in mpeg7-v2.xsd, line 139.<br>
 */
class MP7JRS_EXPORT Mp7JrsURIFragmentReferenceType :
		public IMp7JrsURIFragmentReferenceType
{
	friend class Mp7JrsURIFragmentReferenceTypeFactory; // constructs objects

public:
	/*
	 * Retrieves the base class of Mp7JrsURIFragmentReferenceType
	 
	 * @return Mp7JrsPtr< Mp7JrsFragmentReferenceType >
	 */
	virtual Mp7JrsPtr< Mp7JrsFragmentReferenceType > GetBase() const;
	/*
	 * Get href attribute.
	 * @return XMLCh *
	 */
	virtual XMLCh * Gethref() const;

	/*
	 * Set href attribute.
	 * @param item XMLCh *
	 */
	// Mandatory
	virtual void Sethref(XMLCh * item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);

	/*
	 * Get isDeferred attribute.
<br>
	 * (Inherited from Mp7JrsFragmentReferenceType)
	 * @return bool
	 */
	virtual bool GetisDeferred() const;

	/*
	 * Get isDeferred attribute validity information.
	 * (Inherited from Mp7JrsFragmentReferenceType)
	 * @return true if attribute value is valid, false if not.
	 */
	virtual bool ExistisDeferred() const;

	/*
	 * Set isDeferred attribute.
<br>
	 * (Inherited from Mp7JrsFragmentReferenceType)
	 * @param item bool
	 */
	virtual void SetisDeferred(bool item, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT);


	/*
	 * Invalidate isDeferred attribute.
	 * (Inherited from Mp7JrsFragmentReferenceType)
	 
	 * (Validate it again by setting a value)
	 */
	virtual void InvalidateisDeferred();

	/*
	 * Gets or creates Mp7JrsNodePtr child elements of URIFragmentReferenceType.
	 * Currently just supports rudimentary XPath expressions as URIFragmentReferenceType contains no child elements of type "Mp7JrsNodePtr" at all.

	 * 
	 * Supported XPath expressions for GetOrCreateFromXPath
	 * 
	 * \par<code>/</code>
	 *  - Get the root of this node.
	 * \par<code>..</code>
	 *  - This feature is experimental.
	 *  - Get the ancestor (parent node), or an empty list if the node already is the root node.
	 * 
	 *
	 * @param xpath  the xpath expression to get or create.
	 * @param client the ID in case of locking.
	 * @return the appropriate subelement node list. Can be empty in case of incompatible name/type/index settings.
	 */
	// xpath: mandatory
	// client: optional
	virtual Mp7JrsNodeEnum GetOrCreateFromXPath(const XMLCh *xpath, Mp7JrsClientID client = MP7JRS_UNDEFINED_CLIENT, Mp7JrsXPathCreation flag = MP7JRS_FORCECREATE, Mp7JrsXPathParseContext * context = NULL);

	

	/* Get the class name.
	 * @return The name of this class.
	 */
	virtual XMLCh * ToText() const;

	/* Parse this type.
	 * @param txt buffer to parse from.
	 * @return true if parsing was successful, false otherwise.
	 */
	virtual bool Parse(const XMLCh * const txt);

	/* Serialialize this object to a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent node in DOM tree.
	 */
	virtual void Serialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement* parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement** newElem = NULL);

	/* Deserialize this object from a DOM tree.
	 * @param doc DOM document.
	 * @param parent Parent element in DOM tree.
	 * @param current Current element in DOM tree.
	 */
	virtual bool Deserialize(XERCES_CPP_NAMESPACE_QUALIFIER DOMDocument * doc, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement * parent, XERCES_CPP_NAMESPACE_QUALIFIER DOMElement ** current);

	/* Creates and inserts a Childnode of the specified Type
	 * @param type The tag type of the child to be created (tag name).
	 * @param xsitype The xsi type of the child to be created if available.
	 * @return the created child with the correct dynamic type for the specified type.
	 */
	virtual Mp7JrsNodePtr CreateChild(const XMLCh * const elementname, const XMLCh * const xsitype);
		 
// no includefile for extension defined 
// file Mp7JrsURIFragmentReferenceType_ExtMyMethodDef.h


public:

	virtual ~Mp7JrsURIFragmentReferenceType();

protected:
	Mp7JrsURIFragmentReferenceType();
	virtual void DeepCopy(const Mp7JrsNodePtr &original);

	virtual Mp7JrsNodeEnum GetAllChildElements() const;

	virtual Mp7JrsNodePtr GetBaseRoot();
	virtual const Mp7JrsNodePtr GetBaseRoot() const;

private:
	XMLCh * m_href;

	// Base Class
	Mp7JrsPtr< Mp7JrsFragmentReferenceType > m_Base;


// no includefile for extension defined 
// file Mp7JrsURIFragmentReferenceType_ExtMyPropDef.h


public:
	virtual void Init(); // Called by inheritees to recursively update m_myself
protected:
	void Cleanup();
};

#endif // _2651MP7JRSURIFRAGMENTREFERENCETYPE_H

