/*****************************************************************************/
/* Copyright (C) 2003-2012, JOANNEUM RESEARCH Forschungs Ges.m.b.H.          */
/* Steyrergasse 17, A-8010 Graz, Austria.                                    */
/*                                                                           */
/*  This file is part of the JRS MPEG-7 Library.                             */
/*  http://mpeg-7.joanneum.at                                                */
/*                                                                           */
/*  JRS MPEG-7 Library is free software: you can redistribute it and/or      */
/*  modify it under the terms of the GNU Lesser General Public License       */
/*  (LGPL) as published by the Free Software Foundation, either version 3    */
/*  of the License, or (at your option) any later version.                   */
/*                                                                           */
/*  JRS MPEG-7 Library is distributed in the hope that it will be useful,    */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             */
/*  GNU Lesser General Public License for more details.                      */
/*                                                                           */
/*  You should have received a copy of the GNU Lesser General Public License */
/*  along with this library. If not, see <http://www.gnu.org/licenses/>.     */
/*****************************************************************************/



#ifndef _2383MP7JRSSUMMARYCOMPONENTTYPE_LOCALTYPE_H
#define _2383MP7JRSSUMMARYCOMPONENTTYPE_LOCALTYPE_H


#include <xercesc/util/XMLString.hpp>
#include "Mp7JrsDefines.h"

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_LocalType_ExtInclude.h




/**
 * Generated enumeration Mp7JrssummaryComponentType_LocalType<br>
 * Located at: mpeg7-v2.xsd, line 9112<br>
 * Enumerations: <br>
 * audio (mapped to XML audio) <br>
 * visual (mapped to XML visual) <br>
 * audioVisual (mapped to XML audioVisual) <br>
 * textual (mapped to XML textual) <br>
 * keyAudioClips (mapped to XML keyAudioClips) <br>
 * keyVideoClips (mapped to XML keyVideoClips) <br>
 * keyAudioVisualClips (mapped to XML keyAudioVisualClips) <br>
 * keyFrames (mapped to XML keyFrames) <br>
 * keySounds (mapped to XML keySounds) <br>
 * keyThemes (mapped to XML keyThemes) <br>
 */
class MP7JRS_EXPORT Mp7JrssummaryComponentType_LocalType
{
public:
	/** Mp7JrssummaryComponentType_LocalType enumeration */
	enum Enumeration
	{
		UninitializedEnumeration, 
		audio, // Mapped to audio
		visual, // Mapped to visual
		audioVisual, // Mapped to audioVisual
		textual, // Mapped to textual
		keyAudioClips, // Mapped to keyAudioClips
		keyVideoClips, // Mapped to keyVideoClips
		keyAudioVisualClips, // Mapped to keyAudioVisualClips
		keyFrames, // Mapped to keyFrames
		keySounds, // Mapped to keySounds
		keyThemes, // Mapped to keyThemes
	};
	

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_LocalType_ExtMethodDef.h


	static XMLCh * ToText(Mp7JrssummaryComponentType_LocalType::Enumeration item);
	static Mp7JrssummaryComponentType_LocalType::Enumeration Parse(const XMLCh * const txt);

  static const XMLCh * nsURI(); // For namespace handling

// no includefile for extension defined 
// file Mp7JrssummaryComponentType_LocalType_ExtPropDef.h



};
#endif // _2383MP7JRSSUMMARYCOMPONENTTYPE_LOCALTYPE_H
